import lowlight from 'lowlight';
import { SvelteComponent, init, safe_not_equal, empty, insert, group_outros, transition_out, check_outros, transition_in, detach, destroy_each, element, create_component, attr, mount_component, destroy_component, text, set_data, noop, append } from 'svelte/internal';
import { getCodeBlockMeta } from 'bytemd/helpers';

/* packages/plugin-highlight/src/Element.svelte generated by Svelte v3.20.1 */

function get_each_context(ctx, list, i) {
	const child_ctx = ctx.slice();
	child_ctx[1] = list[i].type;
	child_ctx[2] = list[i].value;
	child_ctx[3] = list[i].tagName;
	child_ctx[4] = list[i].properties;
	child_ctx[0] = list[i].children;
	return child_ctx;
}

// (8:31) 
function create_if_block_1(ctx) {
	let span;
	let span_class_value;
	let current;
	const element_1 = new Element({ props: { children: /*children*/ ctx[0] } });

	return {
		c() {
			span = element("span");
			create_component(element_1.$$.fragment);
			attr(span, "class", span_class_value = /*properties*/ ctx[4] && /*properties*/ ctx[4].className && /*properties*/ ctx[4].className.join(" "));
		},
		m(target, anchor) {
			insert(target, span, anchor);
			mount_component(element_1, span, null);
			current = true;
		},
		p(ctx, dirty) {
			const element_1_changes = {};
			if (dirty & /*children*/ 1) element_1_changes.children = /*children*/ ctx[0];
			element_1.$set(element_1_changes);

			if (!current || dirty & /*children*/ 1 && span_class_value !== (span_class_value = /*properties*/ ctx[4] && /*properties*/ ctx[4].className && /*properties*/ ctx[4].className.join(" "))) {
				attr(span, "class", span_class_value);
			}
		},
		i(local) {
			if (current) return;
			transition_in(element_1.$$.fragment, local);
			current = true;
		},
		o(local) {
			transition_out(element_1.$$.fragment, local);
			current = false;
		},
		d(detaching) {
			if (detaching) detach(span);
			destroy_component(element_1);
		}
	};
}

// (6:2) {#if type === 'text'}
function create_if_block(ctx) {
	let t_value = /*value*/ ctx[2] + "";
	let t;

	return {
		c() {
			t = text(t_value);
		},
		m(target, anchor) {
			insert(target, t, anchor);
		},
		p(ctx, dirty) {
			if (dirty & /*children*/ 1 && t_value !== (t_value = /*value*/ ctx[2] + "")) set_data(t, t_value);
		},
		i: noop,
		o: noop,
		d(detaching) {
			if (detaching) detach(t);
		}
	};
}

// (5:0) {#each children as { type, value, tagName, properties, children }}
function create_each_block(ctx) {
	let current_block_type_index;
	let if_block;
	let if_block_anchor;
	let current;
	const if_block_creators = [create_if_block, create_if_block_1];
	const if_blocks = [];

	function select_block_type(ctx, dirty) {
		if (/*type*/ ctx[1] === "text") return 0;
		if (/*tagName*/ ctx[3] === "span") return 1;
		return -1;
	}

	if (~(current_block_type_index = select_block_type(ctx))) {
		if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
	}

	return {
		c() {
			if (if_block) if_block.c();
			if_block_anchor = empty();
		},
		m(target, anchor) {
			if (~current_block_type_index) {
				if_blocks[current_block_type_index].m(target, anchor);
			}

			insert(target, if_block_anchor, anchor);
			current = true;
		},
		p(ctx, dirty) {
			let previous_block_index = current_block_type_index;
			current_block_type_index = select_block_type(ctx);

			if (current_block_type_index === previous_block_index) {
				if (~current_block_type_index) {
					if_blocks[current_block_type_index].p(ctx, dirty);
				}
			} else {
				if (if_block) {
					group_outros();

					transition_out(if_blocks[previous_block_index], 1, 1, () => {
						if_blocks[previous_block_index] = null;
					});

					check_outros();
				}

				if (~current_block_type_index) {
					if_block = if_blocks[current_block_type_index];

					if (!if_block) {
						if_block = if_blocks[current_block_type_index] = if_block_creators[current_block_type_index](ctx);
						if_block.c();
					}

					transition_in(if_block, 1);
					if_block.m(if_block_anchor.parentNode, if_block_anchor);
				} else {
					if_block = null;
				}
			}
		},
		i(local) {
			if (current) return;
			transition_in(if_block);
			current = true;
		},
		o(local) {
			transition_out(if_block);
			current = false;
		},
		d(detaching) {
			if (~current_block_type_index) {
				if_blocks[current_block_type_index].d(detaching);
			}

			if (detaching) detach(if_block_anchor);
		}
	};
}

function create_fragment(ctx) {
	let each_1_anchor;
	let current;
	let each_value = /*children*/ ctx[0];
	let each_blocks = [];

	for (let i = 0; i < each_value.length; i += 1) {
		each_blocks[i] = create_each_block(get_each_context(ctx, each_value, i));
	}

	const out = i => transition_out(each_blocks[i], 1, 1, () => {
		each_blocks[i] = null;
	});

	return {
		c() {
			for (let i = 0; i < each_blocks.length; i += 1) {
				each_blocks[i].c();
			}

			each_1_anchor = empty();
		},
		m(target, anchor) {
			for (let i = 0; i < each_blocks.length; i += 1) {
				each_blocks[i].m(target, anchor);
			}

			insert(target, each_1_anchor, anchor);
			current = true;
		},
		p(ctx, [dirty]) {
			if (dirty & /*children*/ 1) {
				each_value = /*children*/ ctx[0];
				let i;

				for (i = 0; i < each_value.length; i += 1) {
					const child_ctx = get_each_context(ctx, each_value, i);

					if (each_blocks[i]) {
						each_blocks[i].p(child_ctx, dirty);
						transition_in(each_blocks[i], 1);
					} else {
						each_blocks[i] = create_each_block(child_ctx);
						each_blocks[i].c();
						transition_in(each_blocks[i], 1);
						each_blocks[i].m(each_1_anchor.parentNode, each_1_anchor);
					}
				}

				group_outros();

				for (i = each_value.length; i < each_blocks.length; i += 1) {
					out(i);
				}

				check_outros();
			}
		},
		i(local) {
			if (current) return;

			for (let i = 0; i < each_value.length; i += 1) {
				transition_in(each_blocks[i]);
			}

			current = true;
		},
		o(local) {
			each_blocks = each_blocks.filter(Boolean);

			for (let i = 0; i < each_blocks.length; i += 1) {
				transition_out(each_blocks[i]);
			}

			current = false;
		},
		d(detaching) {
			destroy_each(each_blocks, detaching);
			if (detaching) detach(each_1_anchor);
		}
	};
}

function instance($$self, $$props, $$invalidate) {
	let { children } = $$props;

	$$self.$set = $$props => {
		if ("children" in $$props) $$invalidate(0, children = $$props.children);
	};

	return [children];
}

class Element extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance, create_fragment, safe_not_equal, { children: 0 });
	}
}

/* packages/plugin-highlight/src/Highlight.svelte generated by Svelte v3.20.1 */

function create_fragment$1(ctx) {
	let pre;
	let code;
	let code_class_value;
	let current;
	const elements = new Element({ props: { children: /*items*/ ctx[1] } });

	return {
		c() {
			pre = element("pre");
			code = element("code");
			create_component(elements.$$.fragment);
			attr(code, "class", code_class_value = `hljs language-${/*lang*/ ctx[0]}`);
		},
		m(target, anchor) {
			insert(target, pre, anchor);
			append(pre, code);
			mount_component(elements, code, null);
			current = true;
		},
		p(ctx, [dirty]) {
			const elements_changes = {};
			if (dirty & /*items*/ 2) elements_changes.children = /*items*/ ctx[1];
			elements.$set(elements_changes);

			if (!current || dirty & /*lang*/ 1 && code_class_value !== (code_class_value = `hljs language-${/*lang*/ ctx[0]}`)) {
				attr(code, "class", code_class_value);
			}
		},
		i(local) {
			if (current) return;
			transition_in(elements.$$.fragment, local);
			current = true;
		},
		o(local) {
			transition_out(elements.$$.fragment, local);
			current = false;
		},
		d(detaching) {
			if (detaching) detach(pre);
			destroy_component(elements);
		}
	};
}

function instance$1($$self, $$props, $$invalidate) {
	let { lang } = $$props;
	let { items } = $$props;

	$$self.$set = $$props => {
		if ("lang" in $$props) $$invalidate(0, lang = $$props.lang);
		if ("items" in $$props) $$invalidate(1, items = $$props.items);
	};

	return [lang, items];
}

class Highlight extends SvelteComponent {
	constructor(options) {
		super();
		init(this, options, instance$1, create_fragment$1, safe_not_equal, { lang: 0, items: 1 });
	}
}

function highlight() {
    return {
        renderNode(node) {
            const meta = getCodeBlockMeta(node);
            if (!meta || !meta.language || !lowlight.getLanguage(meta.language))
                return;
            return {
                component: Highlight,
                props: {
                    lang: meta.language,
                    items: lowlight.highlight(meta.language, meta.value).value,
                },
            };
        },
    };
}

export default highlight;
//# sourceMappingURL=index.esm.js.map
